"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parse_cli_args_1 = require("@pnpm/parse-cli-args");
const cmd_1 = require("./cmd");
const shortHands_1 = require("./shortHands");
const RENAMED_OPTIONS = {
    'lockfile-directory': 'lockfile-dir',
    'prefix': 'dir',
    'shrinkwrap-directory': 'lockfile-dir',
    'store': 'store-dir',
};
function parseCliArgs(inputArgv) {
    return parse_cli_args_1.default({
        getCommandLongName: cmd_1.getCommandFullName,
        getTypesByCommandName: cmd_1.getCliOptionsTypes,
        globalOptionsTypes: cmd_1.GLOBAL_OPTIONS,
        isKnownCommand: (commandName) => typeof cmd_1.default[commandName] !== 'undefined',
        renamedOptions: RENAMED_OPTIONS,
        shortHands: shortHands_1.default,
    }, inputArgv);
}
exports.default = parseCliArgs;
